#include<windows.h>
#include<iostream.h>
#include<stdlib.h>
#include<time.h>
#include<math.h>
#include<GL/gl.h>
#include<GL/glu.h>
#include<GL/glaux.h>

void InitGL(void);

static void CALLBACK Key_6(void);
static void CALLBACK Key_4(void);
static void CALLBACK Key_8(void);
static void CALLBACK Key_2(void);

static void CALLBACK Key_space(void);
static void CALLBACK ResizeWindow(GLsizei w, GLsizei h);
static void CALLBACK Draw(void);
bool physics=false;
float velocityx=100,velocityy=0,velocityz=72;
const float acceleration=-9.8;
static float aspectRatio=0;
float bounce=.97,ballsize=0.2;
float speed=10000.;
float x=0,y=speed,z=0;
int angle=0,angley=0;
float rotatez=0,rotatex=0;

static void CALLBACK Key_space(void)
{
	if (physics==false)
		physics=true;
	else 
		physics=false;
}
static void CALLBACK Key_4(void)
{
	angle-=3;
}
static void CALLBACK Key_6(void)
{
	angle+=3;
}
static void CALLBACK Key_8(void)
{
	angley+=3;
}
static void CALLBACK Key_2(void)
{
	angley-=3;
}


static void CALLBACK ResizeWindow(GLsizei w, GLsizei h)
{
    h = (h == 0) ? 1 : h;
	w = (w == 0) ? 1 : w;
	glViewport( 0, 0, w, h );
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
	aspectRatio=(GLfloat)w/(GLfloat)h;
    gluPerspective( 30.0, aspectRatio, 0.1f, 20.0f );
	// select the Modelview matrix
    glMatrixMode( GL_MODELVIEW );
}
static void CALLBACK Draw(void)
{

	glEnable(GL_DEPTH_TEST);
//	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT1);
	GLfloat position1[]= {0.0,0.5,0.0,0.7};
	GLfloat diffuse1[]={1.0f,1.0f,1.0f,0.7f};
	GLfloat specular1[]={0.0f,0.0f,0.0f,1.0f};
	GLfloat ambient1[]={0.9f,0.9f,0.9f,1.5f};
	glLightfv(GL_LIGHT1,GL_AMBIENT,ambient1);
	glLightfv(GL_LIGHT1,GL_DIFFUSE,diffuse1);
	glLightfv(GL_LIGHT1,GL_SPECULAR,specular1);

	glLightfv(GL_LIGHT1,GL_POSITION,position1);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0.0f,-1.3f,-10.0f);
	glRotatef(angley,1.0,0.0,0.0);
	glRotatef(angle,0.0,1.0,0.0);

	if (physics==true)
	{
		x+=velocityx;
		y+=velocityy;
		z+=velocityz;
		
		if (y<=0)
			velocityy=bounce*(abs(velocityy));
		if (y>=speed*3)
			velocityy=bounce*(-abs(velocityy));
		if (x<=-speed+ballsize*speed)
			velocityx=bounce*(abs(velocityx));
		if (x>=speed-ballsize*speed)
			velocityx=bounce*(-abs(velocityx));
		if (z<=-speed+ballsize*speed)
			velocityz=bounce*(abs(velocityz));
		if (z>=speed-ballsize*speed)
			velocityz=bounce*(-abs(velocityz));
		if (y>=9.8)
			velocityy+=acceleration;
		else
		{
			rotatex+=velocityx/10;
			rotatez-=velocityz/10;
			if (velocityx>0)
				velocityx-=.1;
			if (velocityz>0)
				velocityz-=.1;
			if (velocityx<0)
				velocityx+=.1;
			if (velocityz<0)
				velocityz+=.1;
		}

	}	
	glBegin(GL_QUADS);
		glColor4f(1.0,0.9,0.5,1.0);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(-1.0f,0.0f,1.0f);
		glVertex3f(-1.0f,0.0f,-1.0f);
		glVertex3f(1.0f,0.0f,-1.0f);
		glEnd();
	glBegin(GL_QUADS);
		glColor3f(0.2,1.0,0.1);
		glVertex3f(1.0f,2.0f,-1.0f);
		glVertex3f(-1.0f,2.0f,-1.0f);
		glVertex3f(-1.0f,0.0f,-1.0f);
		glVertex3f(1.0f,0.0f,-1.0f);
		glEnd();

	glBegin(GL_QUADS);
		glColor3f(1.0,0.8,0.8);
		glVertex3f(1.0f,2.0f,-1.0f);
		glVertex3f(1.0f,2.0f,1.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(1.0f,0.0f,-1.0f);
		glEnd();

	glBegin(GL_QUADS);
		glColor3f(0.8,0.7,0.9);
		glVertex3f(-1.0f,2.0f,1.0f);
		glVertex3f(-1.0f,2.0f,-1.0f);
		glVertex3f(-1.0f,0.0f,-1.0f);
		glVertex3f(-1.0f,0.0f,1.0f);
		glEnd();


	glTranslatef(x/speed,(y/speed)+ballsize,z/speed);
	glColor4f(1.0,0.0,0.0,0.0);
	glRotatef(-rotatex,0.0,0.0,1.0);
	glRotatef(-rotatez,1.0,0.0,0.0);
	auxWireSphere(ballsize);

	glFlush();
	auxSwapBuffers();

}




void OpenGLInit(void)
{
    glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
    glClearDepth( 1.0f );
	glDepthFunc( GL_LEQUAL );

    glEnable( GL_DEPTH_TEST );

}
int main()
{
	bounce-=.022;
	srand(time(0));
    auxInitDisplayMode(AUX_DOUBLE | AUX_RGB );
    auxInitPosition( 0, 0, 1000, 1000 );
    auxInitWindow( "physics" );
    OpenGLInit();

    auxKeyFunc( AUX_SPACE, Key_space ); 
	auxKeyFunc( AUX_4, Key_4);
	auxKeyFunc( AUX_6, Key_6);
	auxKeyFunc( AUX_8, Key_8);
	auxKeyFunc( AUX_2, Key_2);
	auxKeyFunc( AUX_9, Key_8);
	auxKeyFunc( AUX_9, Key_6);
	auxKeyFunc( AUX_7, Key_8);
	auxKeyFunc( AUX_7, Key_4);
	auxKeyFunc( AUX_1, Key_2);
	auxKeyFunc( AUX_1, Key_4);
	auxKeyFunc( AUX_3, Key_2);
	auxKeyFunc( AUX_3, Key_6);

    auxReshapeFunc( ResizeWindow );


	auxIdleFunc(Draw);
	auxMainLoop(Draw);
	return 0;
}
